// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// GetChatStatisticsRequest represents TL type `getChatStatistics#137e8198`.
type GetChatStatisticsRequest struct {
	// Chat identifier
	ChatID int64
	// Pass true if a dark theme is used by the application
	IsDark bool
}

// GetChatStatisticsRequestTypeID is TL type id of GetChatStatisticsRequest.
const GetChatStatisticsRequestTypeID = 0x137e8198

// Ensuring interfaces in compile-time for GetChatStatisticsRequest.
var (
	_ bin.Encoder     = &GetChatStatisticsRequest{}
	_ bin.Decoder     = &GetChatStatisticsRequest{}
	_ bin.BareEncoder = &GetChatStatisticsRequest{}
	_ bin.BareDecoder = &GetChatStatisticsRequest{}
)

func (g *GetChatStatisticsRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.ChatID == 0) {
		return false
	}
	if !(g.IsDark == false) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *GetChatStatisticsRequest) String() string {
	if g == nil {
		return "GetChatStatisticsRequest(nil)"
	}
	type Alias GetChatStatisticsRequest
	return fmt.Sprintf("GetChatStatisticsRequest%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*GetChatStatisticsRequest) TypeID() uint32 {
	return GetChatStatisticsRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*GetChatStatisticsRequest) TypeName() string {
	return "getChatStatistics"
}

// TypeInfo returns info about TL type.
func (g *GetChatStatisticsRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "getChatStatistics",
		ID:   GetChatStatisticsRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "ChatID",
			SchemaName: "chat_id",
		},
		{
			Name:       "IsDark",
			SchemaName: "is_dark",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *GetChatStatisticsRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getChatStatistics#137e8198 as nil")
	}
	b.PutID(GetChatStatisticsRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *GetChatStatisticsRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getChatStatistics#137e8198 as nil")
	}
	b.PutInt53(g.ChatID)
	b.PutBool(g.IsDark)
	return nil
}

// Decode implements bin.Decoder.
func (g *GetChatStatisticsRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getChatStatistics#137e8198 to nil")
	}
	if err := b.ConsumeID(GetChatStatisticsRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode getChatStatistics#137e8198: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *GetChatStatisticsRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getChatStatistics#137e8198 to nil")
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode getChatStatistics#137e8198: field chat_id: %w", err)
		}
		g.ChatID = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode getChatStatistics#137e8198: field is_dark: %w", err)
		}
		g.IsDark = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (g *GetChatStatisticsRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if g == nil {
		return fmt.Errorf("can't encode getChatStatistics#137e8198 as nil")
	}
	b.ObjStart()
	b.PutID("getChatStatistics")
	b.Comma()
	b.FieldStart("chat_id")
	b.PutInt53(g.ChatID)
	b.Comma()
	b.FieldStart("is_dark")
	b.PutBool(g.IsDark)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (g *GetChatStatisticsRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if g == nil {
		return fmt.Errorf("can't decode getChatStatistics#137e8198 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("getChatStatistics"); err != nil {
				return fmt.Errorf("unable to decode getChatStatistics#137e8198: %w", err)
			}
		case "chat_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode getChatStatistics#137e8198: field chat_id: %w", err)
			}
			g.ChatID = value
		case "is_dark":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode getChatStatistics#137e8198: field is_dark: %w", err)
			}
			g.IsDark = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetChatID returns value of ChatID field.
func (g *GetChatStatisticsRequest) GetChatID() (value int64) {
	if g == nil {
		return
	}
	return g.ChatID
}

// GetIsDark returns value of IsDark field.
func (g *GetChatStatisticsRequest) GetIsDark() (value bool) {
	if g == nil {
		return
	}
	return g.IsDark
}

// GetChatStatistics invokes method getChatStatistics#137e8198 returning error if any.
func (c *Client) GetChatStatistics(ctx context.Context, request *GetChatStatisticsRequest) (ChatStatisticsClass, error) {
	var result ChatStatisticsBox

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return result.ChatStatistics, nil
}
